<?php

namespace myresto\controllers;

use Yii;
use myresto\models\SyncAccountToJurnal;
use myresto\models\SyncAccountToJurnalSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

use myresto\models\SyncConfig;

/**
 * SyncAccountToJurnalController implements the CRUD actions for SyncAccountToJurnal model.
 */
class SyncAccountToJurnalController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all SyncAccountToJurnal models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new SyncAccountToJurnalSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single SyncAccountToJurnal model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new SyncAccountToJurnal model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new SyncAccountToJurnal();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->payment_fpkey]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing SyncAccountToJurnal model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->payment_fpkey]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing SyncAccountToJurnal model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the SyncAccountToJurnal model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return SyncAccountToJurnal the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = SyncAccountToJurnal::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }

    public function actionUpdateSync() {
        $model = new SyncConfig();

        if (Yii::$app->request->post()) {
            $post = Yii::$app->request->post();
            $accountPayments = $post['accountPayments'];
            $payments = new SyncConfig();
            $payments = $payments->getPaymentData();
            Yii::$app->db->createCommand("DELETE FROM sync_account_to_jurnal WHERE type_con = 'resto'")->execute();

            foreach ($accountPayments as $key => $value) {
                $count = SyncAccountToJurnal::find()->where(['type_con' => 'resto'])
                    ->andWhere(['payment_fpkey' => $key])
                    ->count();

                if ($count) {
                    // update
                    $syncAccountToJurnal = SyncAccountToJurnal::findOne(['payment_fpkey' => $key]);
                    $syncAccountToJurnal->payment_type = $payments[$key];
                    $syncAccountToJurnal->nama_akun = $value;
                    $syncAccountToJurnal->save();
                } else {
                    // insert
                    $syncAccountToJurnal = new SyncAccountToJurnal();
                    $syncAccountToJurnal->payment_fpkey = $key;
                    $syncAccountToJurnal->payment_type = $payments[$key];
                    $syncAccountToJurnal->nama_akun = $value;
                    $syncAccountToJurnal->save();
                }
            }
            
            $session = Yii::$app->session;
            $session->addFlash('success', "Configuration saved");
            $config = SyncConfig::find()->where(['type_con' => 'resto'])->one();
            $branchCode = $config->branch_code;
            return $this->redirect(['sync-config/update', 'id' => $branchCode]);
        }

        return $this->render('update-sync', [
            'model' => $model,
        ]);
    }
}
